from time import time
from plot import plot
from wrap import naive, dynamic, shortest, binary, linear, divide

runs = 10

# method, name, width, count
comparison = naive, 'naive', 1, 21, 1, 1, 21, 1
# comparison = dynamic, 'dynamic', 0, 1001, 50, 0, 5001, 250
# comparison = shortest, 'shortest', 0, 5001, 250, 0, 25001, 1250
# comparison = binary, 'binary', 0, 50001, 2500, 0, 250001, 12500
# comparison = linear, 'linear', 0, 50001, 2500, 0, 250001, 12500
# comparison = divide, 'divide', 0, 50001, 2500, 0, 250001, 12500

method, name, xmin, xmax, xstep, ymin, ymax, ystep = comparison
datas = []
for i in range(runs):
    data = []
    for words in range(ymin, ymax, ystep):
        words = max(1, words)
        text = ' '.join(['a'] * words)
        row = []
        for width in range(xmin, xmax, xstep):
            width = max(1, width)
            t = time()
            lines = method(text, width)
            row.append(time() - t)
            print len(lines),
        data.append(row)
        print
    datas.append(data)
data = [map(min, zip(*r)) for r in zip(*datas)]

d = plot(
    data,
    u'Width', u'1 \u2013 %s characters' % u'{:,}'.format(xmax - 1).replace(u',', u'\u200a'),
    u'Count', u'1 \u2013 %s words' % u'{:,}'.format(ymax - 1).replace(u',', u'\u200a'),
    u'Time', u'0.0 \u2013 %.1f second')

d.pdf('%s.pdf' % name)
d.page(0).svg('%s.svg' % name)
d.page(0).image(144, 'rgb').png('%s.png' % name)

from flat import view
view(d.pdf()) # preview in Even



